Package org.apache.sysds.runtime.compress.estim.encoding

## Interface IEncode

All Known Implementing Classes:
  `ConstEncoding`, `DenseEncoding`, `EmptyEncoding`, `SparseEncoding`

    public interface IEncode

This interface covers an intermediate encoding for the samples to improve the efficiency of the joining of sample column groups.

### Field Summary

Fields
`static org.apache.commons.logging.Log` `LOG`

### Method Summary

All Methods Instance Methods Abstract Methods
`IEncode` `combine​(IEncode e)` Combine two encodings, note it should be guaranteed by the caller that the number of unique multiplied does not overflow Integer.
`EstimationFactors` `extractFacts​(int nRows, double tupleSparsity, double matrixSparsity, CompressionSettings cs)` Extract the compression facts for this column group.
`int` `getUnique()` Get the number of unique values in this encoding
`boolean` `isDense()` Signify if the counts are including zero or without zero.

### Field Detail

#### LOG

    static final org.apache.commons.logging.Log LOG

### Method Detail

#### combine

    IEncode combine​(IEncode e)

Combine two encodings, note it should be guaranteed by the caller that the number of unique multiplied does not overflow Integer.

Parameters:
  `e` - The other side to combine with
Returns:
  The combined encoding

#### getUnique

    int getUnique()

Get the number of unique values in this encoding

Returns:
  The number of unique values.

#### extractFacts

    EstimationFactors extractFacts​(int nRows,
                                   double tupleSparsity,
                                   double matrixSparsity,
                                   CompressionSettings cs)

Extract the compression facts for this column group.

Parameters:
  `nRows` - The total number of rows
  `tupleSparsity` - The Sparsity of the unique tuples
  `matrixSparsity` - The matrix sparsity
  `cs` - The compression settings
Returns:
  A EstimationFactors object

#### isDense

    boolean isDense()

Signify if the counts are including zero or without zero.

Returns:
  is dense